****************************************************************************************************			
* Pantalla "std" 	$0e00-$23ff - SAM offset = $0e00 / $200 =  7 = #%0000111
* buffer				$2600-3bff	- SAM offset = $2600 / $200 = 19 = #%0010011
****************************************************************************************************			
			opt	cd
			opt	ct
			org	$4500					; donde ubicar el programa
inicio	sts	$0114					; save stack
			tfr	cc,a					; get CC
			tfr	dp,b					; and DP
			std	CcDp					; save them
			orcc	#$50					; deshabilita interrupciones
****************************************************************************************************
* SYSTEM CONFIGURATION
****************************************************************************************************
			lda	#$e0					; value for PMode3, SCREEN1,0
			sta	$ffd7					; ROM at double spped
			sta	$ffc7					; offset b1=1  (lsb) --> $e00
			sta	$ffc9					; offset b2=1
			sta	$ffcb					; offset b3=1
			sta	$ffcc					; offset b4=0
			sta	$ffce					; offset b5=0
			sta	$ffd0					; offset b6=0
			sta	$ffd2					; offset b7=0  (MSB) --> 0000111 = 7
			sta	$ffc0					; SAM V0=0
			sta	$ffc3					; SAM V1=1
			sta	$ffc5					; SAM V2=1  --> PMODE3
			sta	$ff22					; PIA=$e0   --> 6144 bytes, palette 0
			lda	#$04					; set bit 2
			sta	$ff03					; to detect FS at end of screen
****************************************************************************************************
			ldx	#$0e00				; origen de pantalla (inicial donde est imagen a mover)
			stx	origen				; guardar puntero
			ldx	#$2600				; destino sin desplazar
			stx	destino				; guardar puntero
			ldb	#192					; filas a desplazar para mover toda la pantalla
			stb	>$0076				; guardar en variable pagina 0

			opt 	cc
;S1			lda	#191					; numero de lineas a hacer scroll (la ltima NO)
S1			lda	#47					; numero de lineas a hacer scroll (la ltima NO)
			sta	>$0077				; guardar en variable pagina 0
			clra							; make 
			clrb							; 16 bits zero in regD
			lds	#0						; clear regsiter
			ldx	#0						; clear regsiter
			ldy	#0						; clear regsiter
			ldu	destino				; point to destination
			leau	32,u					; advance one scanline
			pshu	d,x,y,s				;
			pshu	d,x,y,s				;
			pshu	d,x,y,s				;
			pshu	d,x,y,s				; limpiar los 32 bytes de la primera linea

			lds	origen				; point to beginning of ORIGIN line
			leau	40,u					; point to 8th byte of next line (Destination)
			
			opt	cc
Cpy1L		puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes. ONE line copied
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes. TWO lines copied
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes. THREE lines copied
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes. FOUR lines copied
			leau  16,u					; to point to next 8 bytes
			dec	>$0077				; decrement counter
			bne	Cpy1L					; not yet done, loop

			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes. 189 line copied
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes. 190 line copied
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes. 191 (LAST) line copied
			
			opt 	cc
			lda	$ff02					; limpiar indicador de interrupcin
eHs		lda	$ff03					; lleg interrupcin HSYNC? (la de final de pantalla!)
			bpl	eHs					; esperar
											; cambiar inicio de pantalla en SAM
cambio	lda	>$0076				; lee contador numero de scrolls a realizar (+1)
			anda	#1						; usa bit cero
			beq	par					; si es par mostrar buffer
											; si es impar mostrar 'std'
impar		sta	$ffcb					; 1
			sta	$ffce					; 0 = #%0000111 = 7 
			bra	actPun				; salta codigo para Pares
par		sta	$ffca					; 0
			sta	$ffcf					; 1 = #%0010011 = 19 (valor x buffer)
											; cambiar punteros
actPun	ldx	destino				; toma destino (nuevo origen)
			ldy	origen				; toma origen (nuevo destino)
			sty	destino				; actualiza destino actual
			stx	origen				; actualiza origen actual
			dec	>$0076				; movida la imagen completa?
			lbne	S1						; no, siguiente pixel abajo
			lds	$0114					; restore stack
			ldd	CcDp					; get CC and Dp received values
			tfr	a,cc					; restore CC
			tfr	b,dp					; restore DP
			rts							; return
****************************************************************************************************
origen	fdb	$0000
destino	fdb	$0000
CcDp		fdb	$0000
			end 	inicio
